package com.fp.persistence.pgeneral.trans;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;

import com.fp.dto.hb.Cache;
import com.fp.dto.hb.HibernateBean;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENETRANSACTIONPROVISION*/
@Entity(name="TgeneTransactionProvision")
@Table(name="TGENETRANSACTIONPROVISION")
public class TgeneTransactionProvision extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable,Cache{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneTransactionProvision
*/
@EmbeddedId
private TgeneTransactionProvisionKey pk;
@Column(name="PROVISIONFROM", nullable=true)

/**
* B Indica que provisiona desde la fecha de inicio del sobregiro o de la cuota, E incica que provisiona desde el vencimiento del sobregiro o cuota.
*/
private String provisionfrom;

@Column(name="PROVISIONTO", nullable=true)

/**
* E incica que provisiona hasta el vencimiento del sobregiro o cuota. P indica que provisiona hasta la fecha de pago del sobregiro o cuota.
*/
private String provisionto;

@Column(name="BASEAMOUNT", nullable=true)

/**
* Q El monto base para el calculo es el capital de lac cuota, C El monto base es el capital reducido, E Es un valor especial en el que se suma varios tipos de saldo de una cuota.
*/
private String baseamount;

/**Contructor por defecto*/
public TgeneTransactionProvision(){
}
/**Contructor de TgeneTransactionProvision
@param pPk Clave Primaria del entity
*/
public TgeneTransactionProvision(TgeneTransactionProvisionKey pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneTransactionProvision
*/
public static TgeneTransactionProvision find(EntityManager pEntityManager,TgeneTransactionProvisionKey pKey) throws Exception{
    TgeneTransactionProvision obj = pEntityManager.find(TgeneTransactionProvision.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneTransactionProvision
@return El objeto que referencia a la Clave primaria de TgeneTransactionProvision
*/
public TgeneTransactionProvisionKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneTransactionProvision
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneTransactionProvision
*/
public void setPk(TgeneTransactionProvisionKey pPk){
  pk=pPk;
}
/**Obtiene el valor de provisionfrom
@return valor de provisionfrom*/
public String getProvisionfrom(){
  return provisionfrom;
}
/**Fija el valor de provisionfrom
@param pProvisionfrom nuevo Valor de provisionfrom*/
public void setProvisionfrom(String pProvisionfrom){
  provisionfrom=pProvisionfrom;
}

/**Obtiene el valor de provisionto
@return valor de provisionto*/
public String getProvisionto(){
  return provisionto;
}
/**Fija el valor de provisionto
@param pProvisionto nuevo Valor de provisionto*/
public void setProvisionto(String pProvisionto){
  provisionto=pProvisionto;
}

/**Obtiene el valor de baseamount
@return valor de baseamount*/
public String getBaseamount(){
  return baseamount;
}
/**Fija el valor de baseamount
@param pBaseamount nuevo Valor de baseamount*/
public void setBaseamount(String pBaseamount){
  baseamount=pBaseamount;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneTransactionProvision))return false;
    TgeneTransactionProvision that = (TgeneTransactionProvision) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TgeneTransactionProvision
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TgeneTransactionProvision
*/
public Object createInstance(){
 TgeneTransactionProvision instance=new TgeneTransactionProvision();	
 instance.setPk(new TgeneTransactionProvisionKey());
 return instance;
}
/**Clona la entidad TgeneTransactionProvision
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneTransactionProvision p=(TgeneTransactionProvision)this.clone();
  p.setPk((TgeneTransactionProvisionKey)this.pk.cloneMe());
  return p;
}
}
